#include <stdio.h>

void izracunajAB( int n, int *a, int *b )
{
	*a = 0; *b = 0;
	
	while( n % 3 == 0 )
	{
		++(*a);
		n /= 3;
	}	
	
	while( n % 4 == 0 )
	{
		++(*b);
		n /= 4;
	}	
}

int radostan( int n )
{
	int a, b, bKopija, bNaopako;
	
	izracunajAB( n, &a, &b );
	
	if( a > 0 && b > 0 )
	{
		bNaopako = 0; bKopija = b;
		
		while( bKopija > 0 )
		{
			bNaopako = 10 * bNaopako + ( bKopija % 10 );
			bKopija /= 10;
		}
		
		if( a == bNaopako )
			return 1;
	}
	
	return 0;
}

int main( void )
{
	int m, n;
	
	scanf( "%d", &m );
	for( n = 1; n <= m; ++n )
		if( radostan( n ) )
			printf( "%d ", n ); 

	return 0;
}
