#include <stdio.h>

void izracunajAB( int n, int *a, int *b )
{
	*a = 0; *b = 0;
	
	while( n % 2 == 0 )
	{
		++(*a);
		n /= 2;
	}	
	
	while( n % 5 == 0 )
	{
		++(*b);
		n /= 5;
	}	
}

int veseo( int n )
{
	int a, b, ok = 1;
	
	izracunajAB( n, &a, &b );
	
	if( a > 0 && b > 0 )
	{
		int zadnjaZnamenka = 9;
		while( a > 0 )
		{
			if( zadnjaZnamenka < a % 10 )
				ok = 0;
			
			zadnjaZnamenka = a % 10;
			a /= 10; 
		}
		
		zadnjaZnamenka = 9;
		while( b > 0 )
		{
			if( zadnjaZnamenka < b % 10 )
				ok = 0;
			
			zadnjaZnamenka = b % 10;
			b /= 10; 
		}
	}
	else
		ok = 0;
	
	return ok;
}

int main( void )
{
	int x, y, n, koliko = 0;
	
	scanf( "%d%d", &x, &y );
	for( n = x; n <= y; ++n )
		if( veseo( n ) )
			++koliko;		
			
	printf( "%d\n", koliko ); 

	return 0;
}
